diff --git a/tools/testing/selftests/ktf/examples/Makefile b/tools/testing/selftests/ktf/examples/Makefile
new file mode 100644
index 0000000..f3cfcc9
--- /dev/null
+++ b/tools/testing/selftests/ktf/examples/Makefile
@@ -0,0 +1,17 @@
+# Copyright (c) 2016, 2018, Oracle and/or its affiliates. All rights reserved.
+#
+# SPDX-License-Identifier: GPL-2.0
+#
+# Kernel module implementing a few simple examples of KTF tests
+#
+
+include $(srctree)/$(src)/../scripts/ktf_syms.mk
+
+ccflags-y += -I$(srctree)/$(src)/../kernel -I$(src)
+
+obj-m := hello.o h2.o h3.o h4.o
+
+ifdef CONFIG_KGDB
+obj-m += kgdemo.o
+endif
+
diff --git a/tools/testing/selftests/ktf/examples/h2.c b/tools/testing/selftests/ktf/examples/h2.c
new file mode 100644
index 0000000..37a6fbb
--- /dev/null
+++ b/tools/testing/selftests/ktf/examples/h2.c
@@ -0,0 +1,45 @@
+#include <linux/module.h>
+#include "ktf.h"
+
+MODULE_LICENSE("GPL");
+
+KTF_INIT();
+
+#define MAX_CNT 3
+
+struct hello_ctx {
+	struct ktf_context k;
+	int value[MAX_CNT];
+};
+
+static struct hello_ctx myctx = { .value = { 0, 1, 4 } };
+
+TEST(examples, cmp)
+{
+	struct hello_ctx *hctx = KTF_CONTEXT_GET("value", struct hello_ctx);
+
+	EXPECT_INT_EQ(_i, hctx->value[_i]);
+}
+
+static void add_tests(void)
+{
+	ADD_LOOP_TEST(cmp, 0, MAX_CNT);
+}
+
+static int __init hello_init(void)
+{
+	KTF_CONTEXT_ADD(&myctx.k, "value");
+	add_tests();
+	return 0;
+}
+
+static void __exit hello_exit(void)
+{
+	struct ktf_context *kctx = KTF_CONTEXT_FIND("value");
+
+	KTF_CONTEXT_REMOVE(kctx);
+	KTF_CLEANUP();
+}
+
+module_init(hello_init);
+module_exit(hello_exit);
diff --git a/tools/testing/selftests/ktf/examples/h3.c b/tools/testing/selftests/ktf/examples/h3.c
new file mode 100644
index 0000000..a6aca98
--- /dev/null
+++ b/tools/testing/selftests/ktf/examples/h3.c
@@ -0,0 +1,84 @@
+#include <linux/module.h>
+#include "ktf.h"
+
+MODULE_LICENSE("GPL");
+
+KTF_INIT();
+
+DECLARE_F(hello_fixture)
+	struct list_head head;
+};
+
+struct my_element {
+	struct list_head list;
+	int value;
+};
+
+SETUP_F(hello_fixture, hello_setup)
+{
+	int i;
+
+	INIT_LIST_HEAD(&hello_fixture->head);
+	for (i = 0; i < 10; i++) {
+		struct my_element *e = kzalloc(sizeof(*e), GFP_KERNEL);
+
+		e->value = i;
+		list_add_tail(&e->list, &hello_fixture->head);
+	}
+	hello_fixture->ok = true;
+}
+
+TEARDOWN_F(hello_fixture, hello_teardown)
+{
+	struct list_head *p, *next_p;
+
+	/* Just cleanup whatever is left after the test */
+	list_for_each_safe(p, next_p, &hello_fixture->head) {
+		struct my_element *e = list_entry(p, struct my_element, list);
+
+		list_del(&e->list);
+		kfree(e);
+	}
+	EXPECT_TRUE(list_empty(&hello_fixture->head));
+}
+
+INIT_F(hello_fixture, hello_setup, hello_teardown);
+
+TEST_F(hello_fixture, examples, hello_del)
+{
+	int cnt = 0;
+	int cnt_ones = 0;
+	struct my_element *e = kzalloc(sizeof(*e), GFP_KERNEL);
+
+	e->value = 1;
+	list_add(&e->list, &ctx->head);
+
+	list_for_each_entry(e, &ctx->head, list) {
+		if (e->value == 1)
+			cnt_ones++;
+		cnt++;
+	}
+	EXPECT_INT_EQ(11, cnt);
+	EXPECT_INT_EQ(2, cnt_ones);
+}
+
+static void add_tests(void)
+{
+	ADD_TEST(hello_del);
+}
+
+static int __init hello_init(void)
+{
+	add_tests();
+	tlog(T_INFO, "hello: loaded");
+	return 0;
+}
+
+static void __exit hello_exit(void)
+{
+	KTF_CLEANUP();
+	tlog(T_INFO, "hello: unloaded");
+}
+
+module_init(hello_init);
+module_exit(hello_exit);
diff --git a/tools/testing/selftests/ktf/examples/h4.c b/tools/testing/selftests/ktf/examples/h4.c
new file mode 100644
index 0000000..3e85fef
--- /dev/null
+++ b/tools/testing/selftests/ktf/examples/h4.c
@@ -0,0 +1,62 @@
+#include <linux/module.h>
+#include "ktf.h"
+
+MODULE_LICENSE("GPL");
+
+KTF_INIT();
+
+static int count;
+static int ret;
+
+KTF_ENTRY_PROBE(printk, printkhandler)
+{
+	count++;
+
+	KTF_ENTRY_PROBE_RETURN(0);
+}
+
+TEST(examples, entrycheck)
+{
+	count = 0;
+	ASSERT_INT_EQ_GOTO(KTF_REGISTER_ENTRY_PROBE(printk, printkhandler),
+			   0, done);
+	printk(KERN_INFO "Testing kprobe entry...");
+	ASSERT_INT_GT_GOTO(count, 0, done);
+done:
+	KTF_UNREGISTER_ENTRY_PROBE(printk, printkhandler);
+}
+
+KTF_RETURN_PROBE(printk, printkrethandler)
+{
+	ret = KTF_RETURN_VALUE();
+
+	return 0;
+}
+
+TEST(examples, returncheck)
+{
+	char *teststr = "Testing kprobe return...";
+
+	ret = -1;
+	ASSERT_INT_EQ_GOTO(KTF_REGISTER_RETURN_PROBE(printk, printkrethandler),
+			   0, done);
+	printk(KERN_INFO "%s", teststr);
+	ASSERT_INT_EQ_GOTO(ret, strlen(teststr), done);
+done:
+	KTF_UNREGISTER_RETURN_PROBE(printk, printkrethandler);
+}
+
+static int __init hello_init(void)
+{
+	ADD_TEST(entrycheck);
+	ADD_TEST(returncheck);
+	return 0;
+}
+
+static void __exit hello_exit(void)
+{
+	KTF_CLEANUP();
+}
+
+module_init(hello_init);
+module_exit(hello_exit);
diff --git a/tools/testing/selftests/ktf/examples/hello.c b/tools/testing/selftests/ktf/examples/hello.c
new file mode 100644
index 0000000..9c4713f
--- /dev/null
+++ b/tools/testing/selftests/ktf/examples/hello.c
@@ -0,0 +1,38 @@
+#include <linux/module.h>
+#include "ktf.h"
+
+MODULE_LICENSE("GPL");
+
+KTF_INIT();
+
+TEST(examples, hello_ok)
+{
+	EXPECT_TRUE(true);
+}
+
+TEST(examples, hello_fail)
+{
+	EXPECT_TRUE(false);
+}
+
+static void add_tests(void)
+{
+	ADD_TEST(hello_ok);
+	ADD_TEST(hello_fail);
+}
+
+static int __init hello_init(void)
+{
+	add_tests();
+	tlog(T_INFO, "hello: loaded");
+	return 0;
+}
+
+static void __exit hello_exit(void)
+{
+	KTF_CLEANUP();
+	tlog(T_INFO, "hello: unloaded");
+}
+
+module_init(hello_init);
+module_exit(hello_exit);
diff --git a/tools/testing/selftests/ktf/examples/kgdemo.c b/tools/testing/selftests/ktf/examples/kgdemo.c
new file mode 100644
index 0000000..9ce19ff
--- /dev/null
+++ b/tools/testing/selftests/ktf/examples/kgdemo.c
@@ -0,0 +1,61 @@
+#include <linux/module.h>
+#include "ktf.h"
+
+/*
+ * A trivial and somewhat rough example used by the author
+ * for pedagogical purposes, to demonstrate
+ * interactive debugging with kgdb.
+ *
+ * Requires a kernel built with CONFIG_KGDB
+ *
+ * Note: these test breaks into kgdb and/or creates a NULL
+ *       pointer exception and corresponding stack dump, so
+ *       try out in a test environment only!
+ */
+
+MODULE_LICENSE("GPL");
+
+KTF_INIT();
+
+#define MAX_CNT 3
+#include <linux/kgdb.h>
+
+static int kgdemo_cnt;
+static int *bogus_ref;
+
+TEST(kgdb, breakpoint)
+{
+	kgdemo_cnt = 0;
+	printk(KERN_INFO "** Please set kgdemo_cnt = 1 **\n");
+	kgdb_breakpoint();
+	EXPECT_INT_EQ(1, kgdemo_cnt);
+}
+
+TEST(kgdb, nullpointer)
+{
+	int pre = kgdemo_cnt;
+
+	int b = *bogus_ref++;
+
+	EXPECT_INT_EQ(pre + 1, b);
+}
+
+static void add_tests(void)
+{
+	ADD_TEST(breakpoint);
+	ADD_TEST(nullpointer);
+}
+
+static int __init kgdemo_init(void)
+{
+	add_tests();
+	return 0;
+}
+
+static void __exit kgdemo_exit(void)
+{
+	KTF_CLEANUP();
+}
+
+module_init(kgdemo_init);
+module_exit(kgdemo_exit);